'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ConcatSource = require('webpack/lib/ConcatSource');

var _ConcatSource2 = _interopRequireDefault(_ConcatSource);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AmdMainTemplatePlugin = function () {
    function AmdMainTemplatePlugin(options) {
        _classCallCheck(this, AmdMainTemplatePlugin);

        this.name = '[name]';
        this.options = options;
    }

    _createClass(AmdMainTemplatePlugin, [{
        key: 'apply',
        value: function apply(compilation) {
            var _this = this;

            var mainTemplate = compilation.mainTemplate;

            compilation.templatesPlugin('render-with-entry', function (source, chunk, hash) {

                var externals = chunk.modules.filter(function (m) {
                    return m.external;
                });
                var externalsDepsArray = externals.map(function (m) {
                    return _typeof(m.request) === 'object' ? m.request.amd : m.request;
                });
                var externalsArguments = externals.map(function (m) {
                    return '__WEBPACK_EXTERNAL_MODULE_' + m.id + '__';
                });
                var initHandler = void 0,
                    name = void 0,
                    loader = '',
                    requires = '';

                externalsDepsArray.map(function (mod, index) {
                    requires += 'var ' + externalsArguments[index] + ' = require("' + mod + '");';
                });

                externalsArguments = externalsArguments.join(', ');
                externalsDepsArray = JSON.stringify(externalsDepsArray);

                name = mainTemplate.applyPluginsWaterfall("asset-path", _this.name, {
                    hash: hash,
                    chunk: chunk
                });

                initHandler = 'require(' + JSON.stringify(name) + ')';

                if (_this.options.addWebLoader) {
                    try {
                        loader = _fs2.default.readFileSync(_path2.default.join(__dirname, 'loader.js'), "utf8");
                    } catch (e) {
                        throw e;
                    }
                }

                return new _ConcatSource2.default(loader + "define(" + JSON.stringify(name) + ", " + externalsDepsArray + ", function(require, exports, module) { return ", source, "});" + initHandler);
            });

            mainTemplate.plugin('global-hash-paths', function (paths) {
                if (_this.name) paths.push(_this.name);
                return paths;
            });

            mainTemplate.plugin("hash", function (hash) {
                hash.update("exports amd");
                hash.update(_this.name + "");
            });
        }
    }]);

    return AmdMainTemplatePlugin;
}();

exports.default = AmdMainTemplatePlugin;
module.exports = exports['default'];