'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ConcatSource = require('webpack/lib/ConcatSource');

var _ConcatSource2 = _interopRequireDefault(_ConcatSource);

var _ExternalModuleFactoryPlugin = require('webpack/lib/ExternalModuleFactoryPlugin');

var _ExternalModuleFactoryPlugin2 = _interopRequireDefault(_ExternalModuleFactoryPlugin);

var _AmdMainTemplatePlugin = require('./AmdMainTemplatePlugin');

var _AmdMainTemplatePlugin2 = _interopRequireDefault(_AmdMainTemplatePlugin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var WeexRxWebpackPlugin = function () {
  function WeexRxWebpackPlugin(options) {
    _classCallCheck(this, WeexRxWebpackPlugin);

    this.options = Object.assign({}, {
      // set true , will add h5 loader to bundle
      addWebLoader: false
    }, options);
  }

  _createClass(WeexRxWebpackPlugin, [{
    key: 'apply',
    value: function apply(compiler) {
      var _this = this;

      compiler.plugin('this-compilation', function (compilation) {
        compilation.apply(new _AmdMainTemplatePlugin2.default(_this.options));
      });

      compiler.plugin('compile', function (params) {
        params.normalModuleFactory.apply(new _ExternalModuleFactoryPlugin2.default('amd', [function (context, request, callback) {
          // @weex-module/event ignore
          if (/^@weex\-module\//.test(request)) {
            return callback(null, request); // eslint-disable-line
          }
          callback();
        }]));
      });

      compiler.plugin('compilation', function (compilation) {

        compilation.plugin('optimize-chunk-assets', function (chunks, callback) {
          chunks.forEach(function (chunk) {
            if (!chunk.initial) return;
            chunk.files.forEach(function (file) {
              compilation.assets[file] = new _ConcatSource2.default('// {"framework" : "Rx"}', '\n', compilation.assets[file]);
            });
          });
          callback();
        });
      });
    }
  }]);

  return WeexRxWebpackPlugin;
}();

exports.default = WeexRxWebpackPlugin;
module.exports = exports['default'];